"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requireCascadeFromSource = exports.requireCascade = void 0;

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/array/is-array"));

var _appRoot = _interopRequireDefault(require("./app-root"));

var _hasFile = _interopRequireDefault(require("./has-file"));

/* eslint-disable global-require, import/no-dynamic-require */
var NODE_ENV = process.env.NODE_ENV;

var requireCascade_ = function requireCascade_() {
  for (var _len = arguments.length, filenames = new Array(_len), _key = 0; _key < _len; _key++) {
    filenames[_key] = arguments[_key];
  }

  if (!filenames.length) {
    throw Error('requireCascade takes at least one argument');
  }

  var module;
  var filesnames_ = (0, _isArray.default)(filenames[0]) ? filenames[0] : filenames;
  filesnames_.some(function (f) {
    if ((0, _hasFile.default)(f)) {
      var _requiredModule$defau;

      // flow-disable-next-line
      var requiredModule = require("".concat(_appRoot.default, "/").concat(f));

      module = (_requiredModule$defau = requiredModule.default) !== null && _requiredModule$defau !== void 0 ? _requiredModule$defau : requiredModule;
      return true;
    }

    return false;
  });
  return module;
};

var requireCascadeFromSource_ = function requireCascadeFromSource_() {
  for (var _len2 = arguments.length, filenames = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    filenames[_key2] = arguments[_key2];
  }

  return requireCascade_(filenames.map(function (f) {
    return "".concat(NODE_ENV === 'production' || NODE_ENV === 'test' ? 'lib/' : 'src/').concat(f);
  }));
};

var requireCascade = requireCascade_;
exports.requireCascade = requireCascade;
var requireCascadeFromSource = requireCascadeFromSource_;
exports.requireCascadeFromSource = requireCascadeFromSource;