"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearAsync = exports.delAsyncEntry = exports.setAsyncFailure = exports.setAsyncSuccess = exports.setAsyncRequest = exports.FAILURE = exports.SUCCESS = exports.REQUEST = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _objectSpread5 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _lodash = _interopRequireDefault(require("lodash.curryright"));

var REQUEST = 'REQUEST';
exports.REQUEST = REQUEST;
var SUCCESS = 'SUCCESS';
exports.SUCCESS = SUCCESS;
var FAILURE = 'FAILURE';
exports.FAILURE = FAILURE;

var del = function del(state, key) {
  var newState = (0, _objectSpread5.default)({}, state);
  delete newState[key];
  return newState;
};

var setAsyncRequest = (0, _lodash.default)(function (asyncState, params) {
  var _params$status;

  if (params.useStatus === false && params.status) {
    throw Error('setAsyncRequest cannot have both a status option and a useStatus set to false');
  }

  return (0, _objectSpread5.default)({}, asyncState, (0, _defineProperty2.default)({}, params.key, params.useStatus || params.status ? (_params$status = params.status) !== null && _params$status !== void 0 ? _params$status : REQUEST : true));
});
exports.setAsyncRequest = setAsyncRequest;
var setAsyncSuccess = (0, _lodash.default)(function (asyncState, params) {
  var _params$status2;

  if (params.useStatus === false && params.status) {
    throw Error('setAsyncSuccess cannot have both a status option and a useStatus set to false');
  }

  return params.useStatus || params.status ? (0, _objectSpread5.default)({}, asyncState, (0, _defineProperty2.default)({}, params.key, (_params$status2 = params.status) !== null && _params$status2 !== void 0 ? _params$status2 : SUCCESS)) : del(asyncState, params.key);
});
exports.setAsyncSuccess = setAsyncSuccess;
var setAsyncFailure = (0, _lodash.default)(function (asyncState, params) {
  var _params$status3;

  if (params.useStatus === false && params.status) {
    throw Error('setAsyncFailure cannot have both a status option and a useStatus set to false');
  }

  return params.useStatus || params.status ? (0, _objectSpread5.default)({}, asyncState, (0, _defineProperty2.default)({}, params.key, (_params$status3 = params.status) !== null && _params$status3 !== void 0 ? _params$status3 : FAILURE)) : del(asyncState, params.key);
});
exports.setAsyncFailure = setAsyncFailure;

var delAsyncEntry = function delAsyncEntry(key) {
  if (!key) {
    throw Error('delAsyncEntry() requires a key argument');
  }

  if (typeof key === 'string') {
    return function (state) {
      return del(state, key);
    };
  }

  throw Error('Incorrect parameters for delAsyncEntry()');
};

exports.delAsyncEntry = delAsyncEntry;

var clearAsync = function clearAsync(key // flow-disable-next-line
) {
  return typeof key === 'string' ? function (state) {
    return (0, _defineProperty2.default)({}, key, state[key]);
  } : {};
};

exports.clearAsync = clearAsync;