"use strict";

var _recompose = require("recompose");

var _dataReductions = require("./data-reductions");

test('addData', function () {
  var dataState = {
    foo: 'foo'
  };
  expect((0, _dataReductions.addData)(dataState, {
    bar: 'bar'
  })).toEqual({
    foo: 'foo',
    bar: 'bar'
  });
  expect((0, _recompose.compose)((0, _dataReductions.addData)({
    bar: 'bar'
  }))(dataState)).toEqual({
    foo: 'foo',
    bar: 'bar'
  });
});
test('delData', function () {
  var dataState = {
    foo: 'foo'
  };
  expect(function () {
    return (0, _dataReductions.delData)();
  }).toThrow();
  expect(function () {
    return (0, _dataReductions.delData)(1);
  }).toThrow();
  expect((0, _dataReductions.delData)('foo')(dataState)).toEqual({});
  expect((0, _recompose.compose)((0, _dataReductions.delData)('foo'))(dataState)).toEqual({});
});
test('clearData', function () {
  var dataState = {
    foo: 'foo'
  };
  expect((0, _dataReductions.clearData)()).toEqual({});
  expect((0, _dataReductions.clearData)(dataState)).toEqual({});
  expect((0, _recompose.compose)(_dataReductions.clearData)(dataState)).toEqual({});
});