"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeFirstNotification = exports.addMultipleNotifications = exports.addOneNotification = exports.deactivateComponentLoading = exports.activateComponentLoading = exports.deactivatePageLoading = exports.activatePageLoading = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _lodash = _interopRequireDefault(require("lodash.curryright"));

var _lodash2 = _interopRequireDefault(require("lodash.isempty"));

var activatePageLoading = function activatePageLoading(uiState) {
  return (0, _objectSpread2.default)({}, uiState, {
    isPageLoading: true
  });
};

exports.activatePageLoading = activatePageLoading;

var deactivatePageLoading = function deactivatePageLoading(uiState) {
  var isPageLoading = uiState.isPageLoading,
      newUiState = (0, _objectWithoutProperties2.default)(uiState, ["isPageLoading"]);
  return newUiState;
};

exports.deactivatePageLoading = deactivatePageLoading;
var activateComponentLoading = (0, _lodash.default)(function (uiState, name) {
  return (0, _objectSpread2.default)({}, uiState, uiState.loadingComponents || name ? {
    loadingComponents: (0, _objectSpread2.default)({}, uiState.loadingComponents, name ? (0, _defineProperty2.default)({}, name, true) : {})
  } : {});
});
exports.activateComponentLoading = activateComponentLoading;
var deactivateComponentLoading = (0, _lodash.default)(function (uiState, name) {
  var uiStateClone = (0, _objectSpread2.default)({}, uiState);
  var loadingComponents = uiStateClone.loadingComponents,
      uiStateCloneRest = (0, _objectWithoutProperties2.default)(uiStateClone, ["loadingComponents"]);

  if (loadingComponents && name) {
    delete loadingComponents[name];
  }

  return (0, _objectSpread2.default)({}, uiStateCloneRest, !(0, _lodash2.default)(loadingComponents) ? {
    loadingComponents: loadingComponents
  } : {});
});
exports.deactivateComponentLoading = deactivateComponentLoading;
var addOneNotification = (0, _lodash.default)(function (uiState, notification) {
  return (0, _objectSpread2.default)({}, uiState, {
    notifications: (0, _toConsumableArray2.default)(uiState.notifications).concat((0, _toConsumableArray2.default)(notification ? [typeof notification === 'string' ? {
      message: notification
    } : notification] : []))
  });
});
exports.addOneNotification = addOneNotification;
var addMultipleNotifications = (0, _lodash.default)(function (uiState) {
  var notifications = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return (0, _objectSpread2.default)({}, uiState, {
    notifications: (0, _toConsumableArray2.default)(uiState.notifications).concat((0, _toConsumableArray2.default)(notifications.map(function (notification) {
      return typeof notification === 'string' ? {
        message: notification
      } : notification;
    })))
  });
});
exports.addMultipleNotifications = addMultipleNotifications;

var removeFirstNotification = function removeFirstNotification(uiState) {
  return (0, _objectSpread2.default)({}, uiState, {
    notifications: uiState.notifications.splice(1)
  });
};

exports.removeFirstNotification = removeFirstNotification;