"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _propTypes = _interopRequireDefault(require("prop-types"));

/* eslint-disable import/no-extraneous-dependencies */
// flow-disable-next-line
var styles = {
  light: {
    fontWeight: 100
  },
  bold: {
    fontWeight: 500
  },
  bolder: {
    fontWeight: 900
  }
};

var FontWeightJSX = function FontWeightJSX(_ref) {
  var classes = _ref.classes,
      light = _ref.light,
      bolder = _ref.bolder,
      children = _ref.children,
      className = _ref.className,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["classes", "light", "bolder", "children", "className"]);
  var fwClassName = classes.bold;

  if (light) {
    fwClassName = classes.light;
  }

  if (bolder) {
    fwClassName = classes.bolder;
  }

  return _react.default.createElement("span", (0, _extends2.default)({
    className: className ? "".concat(fwClassName, " ").concat(className) : fwClassName
  }, rest), children);
};

FontWeightJSX.propTypes = {
  classes: _propTypes.default.object.isRequired,
  light: _propTypes.default.bool,
  bolder: _propTypes.default.bool,
  className: _propTypes.default.string,
  children: function children(props, propName, componentName) {
    if (!Object.prototype.hasOwnProperty.call(props, propName)) {
      throw new Error("Prop `".concat(propName, "` has type 'any' or 'mixed', but was not provided to `").concat(componentName, "`. Pass undefined or any other value."));
    }
  }
};
var FontWeight = (0, _styles.withStyles)(styles)(FontWeightJSX);
var _default = FontWeight;
exports.default = _default;