"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _knex = _interopRequireDefault(require("./knex"));

var createQuery = function createQuery(tableName) {
  return function (userId, trx) {
    if (typeof tableName !== 'string') {
      throw Error('tableName must be a string');
    }

    var table = trx ? trx(tableName) : (0, _knex.default)(tableName);
    return userId ? table.where("".concat(tableName, ".userId"), userId) : table;
  };
};

module.exports = createQuery;