"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

require("dotenv/config");

var _readEnv = _interopRequireDefault(require("read-env"));

var _checkSetup = require("@sharyn/check-setup");

// flow-disable-next-line
var parsedEnv = (0, _readEnv.default)({
  transformKey: false
});

if (parsedEnv.NODE_ENV === undefined) {
  parsedEnv.NODE_ENV = 'development';
}

if (parsedEnv.ENV_TYPE === undefined) {
  parsedEnv.ENV_TYPE = "local-".concat(parsedEnv.NODE_ENV);
}

parsedEnv.IS_PROD_ENV = parsedEnv.NODE_ENV === 'production';
parsedEnv.IS_DEV_ENV = parsedEnv.NODE_ENV === 'development';
parsedEnv.IS_TEST_ENV = parsedEnv.NODE_ENV === 'test';
parsedEnv.IS_LOCAL_ENV_TYPE = parsedEnv.ENV_TYPE.startsWith('local-');
var envCheckModule = (0, _checkSetup.requireCascadeFromSource)('_server/env-check.js', '_server/check-env.js', '_server/env.js', 'server/env-check.js', 'server/check-env.js', 'server/env.js');
envCheckModule && envCheckModule(parsedEnv); // CommonJS export required to expose the entire object without explicit named exports

module.exports = parsedEnv;