"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _path = _interopRequireDefault(require("path"));

var _checkSetup = require("@sharyn/check-setup");

var _wdsUtil = require("./wds-util");

/* eslint-disable import/no-extraneous-dependencies, global-require */
// flow-disable-next-line
var config = {
  entry: './src/_client/client.js',
  output: {
    filename: "js/bundle.js",
    chunkFilename: '[name].[chunkhash].js',
    path: _path.default.resolve('dist'),
    publicPath: '/static/'
  },
  module: {
    rules: [{
      test: /\.js$/,
      exclude: /node_modules/,
      use: {
        loader: 'babel-loader'
      }
    }]
  },
  plugins: [],
  resolve: {
    alias: {
      joi: 'joi-browser'
    }
  },
  performance: {
    hints: false
  }
};

if ((0, _checkSetup.hasPackage)('compression-webpack-plugin')) {
  // flow-disable-next-line
  var CompressionPlugin = require('compression-webpack-plugin');

  config.plugins.push(new CompressionPlugin());
}

if (_wdsUtil.WDS_PORT) {
  config.output.publicPath = "http://localhost:".concat(_wdsUtil.WDS_PORT, "/static/");
  config.devServer = {
    port: _wdsUtil.WDS_PORT,
    headers: {
      'Access-Control-Allow-Origin': '*'
    }
  };
}

module.exports = config;